
/* definitions for sonlib.h   */
/* %W% last mod on %G% at %U% */
/* Full SCCS path name: (%P%) */


#ifndef __sonlib_h
#define __sonlib_h

/***************/
/* definitions */
/***************/

#ifndef NeedFunctionPrototypes
#if defined(FUNCPROTO) || defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#define NeedFunctionPrototypes 1
#else
#define NeedFunctionPrototypes 0
#endif /* __STDC__ */
#endif /* NeedFunctionPrototypes */

#undef  TRUE
#define TRUE    -1
#undef  FALSE
#define FALSE	0

#define NEW_DBG 	1	/* see new.c for description */

#ifndef MAXPATHLEN
#define MAXPATHLEN		512
#endif

/****************/
/* external     */
/****************/

/*********************************************/
/* structures and global/semiglobal variable */
/*********************************************/

typedef struct {
	long orig_user;		/* Initial user time for process        */
	long orig_system;	/* Initial system time for process      */
	long orig_elapse;	/* Initial elase time for the system    */
	long user;		/* user time for the process            */
	long system;		/* system time for the process          */
	long elapse;		/* elapse time for the process          */
} sTime;

typedef double Rtyp;

/* Definition of program names */
#define PROG_EM		1
#define PROG_XGEOM	2
#define PROG_EMVU	3
#define PROG_PATVU	4

/************************************************************************
*				Used in bug.c				*
************************************************************************/

void
announce_bug(
#if NeedFunctionPrototypes
	char *id_str
#endif
);


void
bug_core(
#if NeedFunctionPrototypes
	int value
#endif
);



/************************************************************************
*				Used in clock.c				*
************************************************************************/

void
WaitMilSec(
#if NeedFunctionPrototypes
	int msec
#endif
);

sTime *
GetTime(
#if NeedFunctionPrototypes
	sTime *stime
#endif
);

char *
TraceTime(
#if NeedFunctionPrototypes
	void
#endif
);

char *
TimeToString(
#if NeedFunctionPrototypes
	sTime *stime
#endif
);

char *
GetDateString(
#if NeedFunctionPrototypes
	void
#endif
);

/************************************************************************
*				Used in expstr.c			*
************************************************************************/

char *
expstr(
#if NeedFunctionPrototypes
	char *istr
#endif
);

/************************************************************************
*				Used in new.c				*
************************************************************************/

extern void
set_new_trace_level(
#if NeedFunctionPrototypes
	int level
#endif
);


extern void
set_new_trace_size(
#if NeedFunctionPrototypes
	int min
#endif
);

extern void
set_new_break_function(
#if NeedFunctionPrototypes
	int alloc_nu,
	void (*func)()
#endif
);

extern char *new(
#if NeedFunctionPrototypes
	unsigned size
#endif
);

extern char *rnew(
#if NeedFunctionPrototypes
	char *ptr,
	unsigned size
#endif
);

extern char *cnew(
#if NeedFunctionPrototypes
	unsigned n,
	unsigned size
#endif
);

extern void sFree(
#if NeedFunctionPrototypes
	char *ptr
#endif
);

extern void
stop_if_nomem(
#if NeedFunctionPrototypes
	int value
#endif
);

extern void
new_core(
#if NeedFunctionPrototypes
	int value
#endif
);

extern void
core_program(
#if NeedFunctionPrototypes
	void
#endif
);

extern void
new_check(
#if NeedFunctionPrototypes
	void
#endif
);

extern void new_print_memory_alloc(
#if NeedFunctionPrototypes
	void
#endif
);

extern void print_all_new(
#if NeedFunctionPrototypes
	void
#endif
);

#if NEW_DBG

extern char *
new_tr(
#if NeedFunctionPrototypes
	char *file,
	int linenu,
	unsigned size
#endif
);

extern void
sFree_tr(
#if NeedFunctionPrototypes
	char *file,
	int linenu,
	char *ptr
#endif
);

extern char *
rnew_tr(
#if NeedFunctionPrototypes
	char *file,
	int linenu,
	char *ptr,
	unsigned size
#endif
);

extern char *cnew_tr(
#if NeedFunctionPrototypes
	char *file,
	int linenu, 
	unsigned n,
	unsigned size
#endif
);


extern void
stop_if_nomem_tr(
#if NeedFunctionPrototypes
	char *file,
	int linenu,
	int value
#endif
);

#define new(size)	new_tr(__FILE__,__LINE__,size)
#define rnew(ptr,size)	rnew_tr(__FILE__,__LINE__,ptr,size)
#define cnew(n,size)	cnew_tr(__FILE__,__LINE__,n,size)
#define sFree(ptr)	sFree_tr(__FILE__,__LINE__,ptr)
#define stop_if_nomem(value) stop_if_nomem_tr(__FILE__,__LINE__,value)


#endif  /* End: NEW_DBG */


/* String utilities definitions */   /*jcr16jul87*/

/************************************************************************
*				Used in strutil.c			*
************************************************************************/

char
*Skip_blnks(
#if NeedFunctionPrototypes
	char *Str
#endif
);

char
*Next_field(
#if NeedFunctionPrototypes
	char *Str
#endif
);

void
Fgets_done(
#if NeedFunctionPrototypes
	void
#endif
);

void
Fgets_reset(
#if NeedFunctionPrototypes
	void
#endif
);

int
Fgets_line_num(
#if NeedFunctionPrototypes
	void
#endif
);

char
*sFgets(
#if NeedFunctionPrototypes
	char *s,
	int n,
	FILE *in
#endif
);

void
rmspace(
#if NeedFunctionPrototypes
	char *strngh
#endif
);

char
*get_sonnet_dir(
#if NeedFunctionPrototypes
	int print_error
#endif
);

char 
*file_delimeter(
#if NeedFunctionPrototypes
	void
#endif
);

void
filename_cat(
#if NeedFunctionPrototypes
	char *basename,
	char *append_string,
	char *delimeter
#endif
);

char *
string(
#if NeedFunctionPrototypes
	char *buf
#endif
);

char *
FileNameExt(
#if NeedFunctionPrototypes
	char *filename,
	char *ext,
	int replace
#endif
);

#ifdef DOS
/************************************************************************
*				Used in dos.c				*
************************************************************************/

#ifdef PWD_H
#include <pwd.h>
#else

int
getuid(
#if NeedFunctionPrototypes
	void
#endif
);


struct passwd *
getpwuid(
#if NeedFunctionPrototypes
	int uid
#endif
);

struct passwd *
getpwnam(
#if NeedFunctionPrototypes
	char *name
#endif
);

#endif /* PWD_H */

#endif /* DOS */

#endif  /* End: __sonlib_h */
